----------------------------------------------------------------------------------
-- Company:             www.kampis-elektroecke.de
-- Engineer:            Daniel Kampert
-- 
-- Create Date:         09.02.2018 16:11:37
-- Design Name: 
-- Module Name:         Top - Top_Arch
-- Project Name: 
-- Target Devices: 
-- Tool Versions:       Vivado 2016.4
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Top is
    Generic ( DATA_WIDTH_PER_CHANNEL : INTEGER := 16;
              MCLK_PRESCALER : INTEGER := 256
              );
    Port (  Clock    : in STD_LOGIC;
            Reset    : in STD_LOGIC;
            Locked   : out STD_LOGIC;
            MCLK     : out STD_LOGIC;
            LRCLK    : out STD_LOGIC;
            I2S_SCLK : out STD_LOGIC;
            I2S_Data : out STD_LOGIC
            );
end Top;

architecture Top_Arch of Top is

    component ClockManager is
        Port (  Reset   : in STD_LOGIC;
                Clock_In: in STD_LOGIC;
                MCLK    : out STD_LOGIC;
                Locked  : out STD_LOGIC
                );
    end component ClockManager;

    component I2S_Top is
        Generic ( DATA_WIDTH_PER_CHANNEL : INTEGER := 16;
                  MCLK_PRESCALER : INTEGER := 256
                  );
        Port (  Clock    : in STD_LOGIC;
                Reset    : in STD_LOGIC;
                MCLK     : out STD_LOGIC;
                LRCLK    : out STD_LOGIC;
                I2S_SCLK : out STD_LOGIC;
                I2S_Data : out STD_LOGIC
                );
    end component;

    signal Clock_Int:   STD_LOGIC := '0';

begin

    MainClock : ClockManager port map ( Reset => Reset,
                                        Clock_In => Clock,
                                        MCLK => Clock_Int,
                                        Locked => Locked
                                        );
                                        
    Audio : I2S_Top generic map (   DATA_WIDTH_PER_CHANNEL => DATA_WIDTH_PER_CHANNEL,
                                    MCLK_PRESCALER => MCLK_PRESCALER
                                    )
                    port map (  Clock => Clock_Int,
                                Reset => Reset,
                                I2S_SCLK => I2S_SCLK,
                                LRCLK => LRCLK,
                                I2S_Data => I2S_Data,
                                MCLK => MCLK
                                );

end Top_Arch;